package de.fitko.fitconnect.client;

import com.google.inject.Guice;
import com.google.inject.Injector;
import de.fitko.fitconnect.dependency.SdkModule;
import de.fitko.fitconnect.api.services.Sender;
import de.fitko.fitconnect.api.services.Subscriber;
import org.springframework.web.client.RestTemplate;

public class SdkClientFactory {

    private static final Injector injector = Guice.createInjector(new SdkModule());

    public static SenderClient senderClient() {
        var sender = injector.getInstance(Sender.class);
        var restTemplate = injector.getProvider(RestTemplate.class).get();
        return new SenderClient(sender, restTemplate);
    }

    public static SubscriberClient subscriberClient(){
        return new SubscriberClient(injector.getInstance(Subscriber.class));
    }
}
